<?php
/**
 * PasteOptions
 *
 * PHP version 5
 *
 * @category Class
 * @package  Aspose\Cells\Cloud
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/* 
 * <summary>
 *  Copyright (c) 2020 Aspose.Cells Cloud
 *  Permission is hereby granted, free of charge, to any person obtaining a copy
 *  of this software and associated documentation files (the "Software"), to deal
 *  in the Software without restriction, including without limitation the rights
 *  to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 *  copies of the Software, and to permit persons to whom the Software is
 *  furnished to do so, subject to the following conditions:
 * 
 *  The above copyright notice and this permission notice shall be included in all 
 *  copies or substantial portions of the Software.
 * 
 *  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 *  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 *  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 *  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 *  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 *  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 *  SOFTWARE.
 * </summary>
 */

/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace Aspose\Cells\Cloud\Model;

use \ArrayAccess;
use \Aspose\Cells\Cloud\ObjectSerializer;

/**
 * PasteOptions Class Doc Comment
 *
 * @category Class
 * @package  Aspose\Cells\Cloud
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */
class PasteOptions implements  ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $swaggerModelName = 'PasteOptions';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerTypes = [
        'paste_type' => 'string',
        'skip_blanks' => 'bool',
        'only_visible_cells' => 'bool',
        'transpose' => 'bool'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerFormats = [
        'paste_type' => null,
        'skip_blanks' => null,
        'only_visible_cells' => null,
        'transpose' => null
    ];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerTypes()
    {
        return self::$swaggerTypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerFormats()
    {
        return self::$swaggerFormats;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'paste_type' => 'PasteType',
        'skip_blanks' => 'SkipBlanks',
        'only_visible_cells' => 'OnlyVisibleCells',
        'transpose' => 'Transpose'
    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'paste_type' => 'setPasteType',
        'skip_blanks' => 'setSkipBlanks',
        'only_visible_cells' => 'setOnlyVisibleCells',
        'transpose' => 'setTranspose'
    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'paste_type' => 'getPasteType',
        'skip_blanks' => 'getSkipBlanks',
        'only_visible_cells' => 'getOnlyVisibleCells',
        'transpose' => 'getTranspose'
    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$swaggerModelName;
    }

    

    

    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['paste_type'] = isset($data['paste_type']) ? $data['paste_type'] : null;
        $this->container['skip_blanks'] = isset($data['skip_blanks']) ? $data['skip_blanks'] : null;
        $this->container['only_visible_cells'] = isset($data['only_visible_cells']) ? $data['only_visible_cells'] : null;
        $this->container['transpose'] = isset($data['transpose']) ? $data['transpose'] : null;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {

        return true;
    }


    /**
     * Gets paste_type
     *
     * @return string
     */
    public function getPasteType()
    {
        return $this->container['paste_type'];
    }

    /**
     * Sets paste_type
     *
     * @param string $paste_type paste_type
     *
     * @return $this
     */
    public function setPasteType($paste_type)
    {
        $this->container['paste_type'] = $paste_type;

        return $this;
    }

    /**
     * Gets skip_blanks
     *
     * @return bool
     */
    public function getSkipBlanks()
    {
        return $this->container['skip_blanks'];
    }

    /**
     * Sets skip_blanks
     *
     * @param bool $skip_blanks skip_blanks
     *
     * @return $this
     */
    public function setSkipBlanks($skip_blanks)
    {
        $this->container['skip_blanks'] = $skip_blanks;

        return $this;
    }

    /**
     * Gets only_visible_cells
     *
     * @return bool
     */
    public function getOnlyVisibleCells()
    {
        return $this->container['only_visible_cells'];
    }

    /**
     * Sets only_visible_cells
     *
     * @param bool $only_visible_cells only_visible_cells
     *
     * @return $this
     */
    public function setOnlyVisibleCells($only_visible_cells)
    {
        $this->container['only_visible_cells'] = $only_visible_cells;

        return $this;
    }

    /**
     * Gets transpose
     *
     * @return bool
     */
    public function getTranspose()
    {
        return $this->container['transpose'];
    }

    /**
     * Sets transpose
     *
     * @param bool $transpose transpose
     *
     * @return $this
     */
    public function setTranspose($transpose)
    {
        $this->container['transpose'] = $transpose;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     *
     * @param integer $offset Offset
     * @param mixed   $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        if (defined('JSON_PRETTY_PRINT')) { // use JSON pretty print
            return json_encode(
                ObjectSerializer::sanitizeForSerialization($this),
                JSON_PRETTY_PRINT
            );
        }

        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}


