<?php
/**
 * PivotFilter
 *
 * PHP version 5
 *
 * @category Class
 * @package  Aspose\Cells\Cloud
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/* 
 * <summary>
 *  Copyright (c) 2020 Aspose.Cells Cloud
 *  Permission is hereby granted, free of charge, to any person obtaining a copy
 *  of this software and associated documentation files (the "Software"), to deal
 *  in the Software without restriction, including without limitation the rights
 *  to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 *  copies of the Software, and to permit persons to whom the Software is
 *  furnished to do so, subject to the following conditions:
 * 
 *  The above copyright notice and this permission notice shall be included in all 
 *  copies or substantial portions of the Software.
 * 
 *  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 *  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 *  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 *  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 *  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 *  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 *  SOFTWARE.
 * </summary>
 */

/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace Aspose\Cells\Cloud\Model;

use \ArrayAccess;
use \Aspose\Cells\Cloud\ObjectSerializer;

/**
 * PivotFilter Class Doc Comment
 *
 * @category Class
 * @description Represents a PivotFilter in PivotFilter Collection.
 * @package  Aspose\Cells\Cloud
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */
class PivotFilter implements  ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $swaggerModelName = 'PivotFilter';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerTypes = [
        'evaluation_order' => 'int',
        'name' => 'string',
        'filter_type' => 'string',
        'auto_filter' => '\Aspose\Cells\Cloud\Model\AutoFilter',
        'field_index' => 'int',
        'measure_fld_index' => 'int',
        'value1' => 'string',
        'member_property_field_index' => 'int',
        'value2' => 'string'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerFormats = [
        'evaluation_order' => 'int32',
        'name' => null,
        'filter_type' => null,
        'auto_filter' => null,
        'field_index' => 'int32',
        'measure_fld_index' => 'int32',
        'value1' => null,
        'member_property_field_index' => 'int32',
        'value2' => null
    ];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerTypes()
    {
        return self::$swaggerTypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerFormats()
    {
        return self::$swaggerFormats;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'evaluation_order' => 'EvaluationOrder',
        'name' => 'Name',
        'filter_type' => 'FilterType',
        'auto_filter' => 'AutoFilter',
        'field_index' => 'FieldIndex',
        'measure_fld_index' => 'MeasureFldIndex',
        'value1' => 'Value1',
        'member_property_field_index' => 'MemberPropertyFieldIndex',
        'value2' => 'Value2'
    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'evaluation_order' => 'setEvaluationOrder',
        'name' => 'setName',
        'filter_type' => 'setFilterType',
        'auto_filter' => 'setAutoFilter',
        'field_index' => 'setFieldIndex',
        'measure_fld_index' => 'setMeasureFldIndex',
        'value1' => 'setValue1',
        'member_property_field_index' => 'setMemberPropertyFieldIndex',
        'value2' => 'setValue2'
    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'evaluation_order' => 'getEvaluationOrder',
        'name' => 'getName',
        'filter_type' => 'getFilterType',
        'auto_filter' => 'getAutoFilter',
        'field_index' => 'getFieldIndex',
        'measure_fld_index' => 'getMeasureFldIndex',
        'value1' => 'getValue1',
        'member_property_field_index' => 'getMemberPropertyFieldIndex',
        'value2' => 'getValue2'
    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$swaggerModelName;
    }

    

    

    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['evaluation_order'] = isset($data['evaluation_order']) ? $data['evaluation_order'] : null;
        $this->container['name'] = isset($data['name']) ? $data['name'] : null;
        $this->container['filter_type'] = isset($data['filter_type']) ? $data['filter_type'] : null;
        $this->container['auto_filter'] = isset($data['auto_filter']) ? $data['auto_filter'] : null;
        $this->container['field_index'] = isset($data['field_index']) ? $data['field_index'] : null;
        $this->container['measure_fld_index'] = isset($data['measure_fld_index']) ? $data['measure_fld_index'] : null;
        $this->container['value1'] = isset($data['value1']) ? $data['value1'] : null;
        $this->container['member_property_field_index'] = isset($data['member_property_field_index']) ? $data['member_property_field_index'] : null;
        $this->container['value2'] = isset($data['value2']) ? $data['value2'] : null;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {

        return true;
    }


    /**
     * Gets evaluation_order
     *
     * @return int
     */
    public function getEvaluationOrder()
    {
        return $this->container['evaluation_order'];
    }

    /**
     * Sets evaluation_order
     *
     * @param int $evaluation_order Gets the Evaluation Order of the pivot filter.
     *
     * @return $this
     */
    public function setEvaluationOrder($evaluation_order)
    {
        $this->container['evaluation_order'] = $evaluation_order;

        return $this;
    }

    /**
     * Gets name
     *
     * @return string
     */
    public function getName()
    {
        return $this->container['name'];
    }

    /**
     * Sets name
     *
     * @param string $name Gets the name of the pivot filter.
     *
     * @return $this
     */
    public function setName($name)
    {
        $this->container['name'] = $name;

        return $this;
    }

    /**
     * Gets filter_type
     *
     * @return string
     */
    public function getFilterType()
    {
        return $this->container['filter_type'];
    }

    /**
     * Sets filter_type
     *
     * @param string $filter_type Gets the autofilter type of the pivot filter.
     *
     * @return $this
     */
    public function setFilterType($filter_type)
    {
        $this->container['filter_type'] = $filter_type;

        return $this;
    }

    /**
     * Gets auto_filter
     *
     * @return \Aspose\Cells\Cloud\Model\AutoFilter
     */
    public function getAutoFilter()
    {
        return $this->container['auto_filter'];
    }

    /**
     * Sets auto_filter
     *
     * @param \Aspose\Cells\Cloud\Model\AutoFilter $auto_filter Gets the autofilter of the pivot filter.
     *
     * @return $this
     */
    public function setAutoFilter($auto_filter)
    {
        $this->container['auto_filter'] = $auto_filter;

        return $this;
    }

    /**
     * Gets field_index
     *
     * @return int
     */
    public function getFieldIndex()
    {
        return $this->container['field_index'];
    }

    /**
     * Sets field_index
     *
     * @param int $field_index Gets the field index of the pivot filter.
     *
     * @return $this
     */
    public function setFieldIndex($field_index)
    {
        $this->container['field_index'] = $field_index;

        return $this;
    }

    /**
     * Gets measure_fld_index
     *
     * @return int
     */
    public function getMeasureFldIndex()
    {
        return $this->container['measure_fld_index'];
    }

    /**
     * Sets measure_fld_index
     *
     * @param int $measure_fld_index Gets the measure field index of the pivot filter.
     *
     * @return $this
     */
    public function setMeasureFldIndex($measure_fld_index)
    {
        $this->container['measure_fld_index'] = $measure_fld_index;

        return $this;
    }

    /**
     * Gets value1
     *
     * @return string
     */
    public function getValue1()
    {
        return $this->container['value1'];
    }

    /**
     * Sets value1
     *
     * @param string $value1 Gets the string value1 of the label pivot filter.
     *
     * @return $this
     */
    public function setValue1($value1)
    {
        $this->container['value1'] = $value1;

        return $this;
    }

    /**
     * Gets member_property_field_index
     *
     * @return int
     */
    public function getMemberPropertyFieldIndex()
    {
        return $this->container['member_property_field_index'];
    }

    /**
     * Sets member_property_field_index
     *
     * @param int $member_property_field_index Gets the member property field index of the pivot filter.
     *
     * @return $this
     */
    public function setMemberPropertyFieldIndex($member_property_field_index)
    {
        $this->container['member_property_field_index'] = $member_property_field_index;

        return $this;
    }

    /**
     * Gets value2
     *
     * @return string
     */
    public function getValue2()
    {
        return $this->container['value2'];
    }

    /**
     * Sets value2
     *
     * @param string $value2 Gets the string value2 of the label pivot filter.
     *
     * @return $this
     */
    public function setValue2($value2)
    {
        $this->container['value2'] = $value2;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     *
     * @param integer $offset Offset
     * @param mixed   $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        if (defined('JSON_PRETTY_PRINT')) { // use JSON pretty print
            return json_encode(
                ObjectSerializer::sanitizeForSerialization($this),
                JSON_PRETTY_PRINT
            );
        }

        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}


