<?php
/**
 * TextOptions
 *
 * PHP version 5
 *
 * @category Class
 * @package  Aspose\Cells\Cloud
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/* 
 * <summary>
 *  Copyright (c) 2020 Aspose.Cells Cloud
 *  Permission is hereby granted, free of charge, to any person obtaining a copy
 *  of this software and associated documentation files (the "Software"), to deal
 *  in the Software without restriction, including without limitation the rights
 *  to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 *  copies of the Software, and to permit persons to whom the Software is
 *  furnished to do so, subject to the following conditions:
 * 
 *  The above copyright notice and this permission notice shall be included in all 
 *  copies or substantial portions of the Software.
 * 
 *  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 *  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 *  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 *  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 *  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 *  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 *  SOFTWARE.
 * </summary>
 */

/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace Aspose\Cells\Cloud\Model;

use \ArrayAccess;
use \Aspose\Cells\Cloud\ObjectSerializer;

/**
 * TextOptions Class Doc Comment
 *
 * @category Class
 * @package  Aspose\Cells\Cloud
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */
class TextOptions implements  ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $swaggerModelName = 'TextOptions';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerTypes = [
        'is_italic' => 'bool',
        'name' => 'string',
        'double_size' => 'double',
        'color' => '\Aspose\Cells\Cloud\Model\Color',
        'is_bold' => 'bool',
        'is_subscript' => 'bool',
        'is_superscript' => 'bool',
        'is_strikeout' => 'bool',
        'underline' => 'string',
        'size' => 'int',
        'outline' => '\Aspose\Cells\Cloud\Model\LineFormat',
        'spacing' => 'double',
        'kerning' => 'double',
        'shadow' => '\Aspose\Cells\Cloud\Model\ShadowEffect',
        'fill' => '\Aspose\Cells\Cloud\Model\FillFormat',
        'underline_color' => '\Aspose\Cells\Cloud\Model\CellsColor'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerFormats = [
        'is_italic' => null,
        'name' => null,
        'double_size' => 'double',
        'color' => null,
        'is_bold' => null,
        'is_subscript' => null,
        'is_superscript' => null,
        'is_strikeout' => null,
        'underline' => null,
        'size' => 'int32',
        'outline' => null,
        'spacing' => 'double',
        'kerning' => 'double',
        'shadow' => null,
        'fill' => null,
        'underline_color' => null
    ];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerTypes()
    {
        return self::$swaggerTypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerFormats()
    {
        return self::$swaggerFormats;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'is_italic' => 'IsItalic',
        'name' => 'Name',
        'double_size' => 'DoubleSize',
        'color' => 'Color',
        'is_bold' => 'IsBold',
        'is_subscript' => 'IsSubscript',
        'is_superscript' => 'IsSuperscript',
        'is_strikeout' => 'IsStrikeout',
        'underline' => 'Underline',
        'size' => 'Size',
        'outline' => 'Outline',
        'spacing' => 'Spacing',
        'kerning' => 'Kerning',
        'shadow' => 'Shadow',
        'fill' => 'Fill',
        'underline_color' => 'UnderlineColor'
    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'is_italic' => 'setIsItalic',
        'name' => 'setName',
        'double_size' => 'setDoubleSize',
        'color' => 'setColor',
        'is_bold' => 'setIsBold',
        'is_subscript' => 'setIsSubscript',
        'is_superscript' => 'setIsSuperscript',
        'is_strikeout' => 'setIsStrikeout',
        'underline' => 'setUnderline',
        'size' => 'setSize',
        'outline' => 'setOutline',
        'spacing' => 'setSpacing',
        'kerning' => 'setKerning',
        'shadow' => 'setShadow',
        'fill' => 'setFill',
        'underline_color' => 'setUnderlineColor'
    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'is_italic' => 'getIsItalic',
        'name' => 'getName',
        'double_size' => 'getDoubleSize',
        'color' => 'getColor',
        'is_bold' => 'getIsBold',
        'is_subscript' => 'getIsSubscript',
        'is_superscript' => 'getIsSuperscript',
        'is_strikeout' => 'getIsStrikeout',
        'underline' => 'getUnderline',
        'size' => 'getSize',
        'outline' => 'getOutline',
        'spacing' => 'getSpacing',
        'kerning' => 'getKerning',
        'shadow' => 'getShadow',
        'fill' => 'getFill',
        'underline_color' => 'getUnderlineColor'
    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$swaggerModelName;
    }

    

    

    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['is_italic'] = isset($data['is_italic']) ? $data['is_italic'] : null;
        $this->container['name'] = isset($data['name']) ? $data['name'] : null;
        $this->container['double_size'] = isset($data['double_size']) ? $data['double_size'] : null;
        $this->container['color'] = isset($data['color']) ? $data['color'] : null;
        $this->container['is_bold'] = isset($data['is_bold']) ? $data['is_bold'] : null;
        $this->container['is_subscript'] = isset($data['is_subscript']) ? $data['is_subscript'] : null;
        $this->container['is_superscript'] = isset($data['is_superscript']) ? $data['is_superscript'] : null;
        $this->container['is_strikeout'] = isset($data['is_strikeout']) ? $data['is_strikeout'] : null;
        $this->container['underline'] = isset($data['underline']) ? $data['underline'] : null;
        $this->container['size'] = isset($data['size']) ? $data['size'] : null;
        $this->container['outline'] = isset($data['outline']) ? $data['outline'] : null;
        $this->container['spacing'] = isset($data['spacing']) ? $data['spacing'] : null;
        $this->container['kerning'] = isset($data['kerning']) ? $data['kerning'] : null;
        $this->container['shadow'] = isset($data['shadow']) ? $data['shadow'] : null;
        $this->container['fill'] = isset($data['fill']) ? $data['fill'] : null;
        $this->container['underline_color'] = isset($data['underline_color']) ? $data['underline_color'] : null;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {

        return true;
    }


    /**
     * Gets is_italic
     *
     * @return bool
     */
    public function getIsItalic()
    {
        return $this->container['is_italic'];
    }

    /**
     * Sets is_italic
     *
     * @param bool $is_italic is_italic
     *
     * @return $this
     */
    public function setIsItalic($is_italic)
    {
        $this->container['is_italic'] = $is_italic;

        return $this;
    }

    /**
     * Gets name
     *
     * @return string
     */
    public function getName()
    {
        return $this->container['name'];
    }

    /**
     * Sets name
     *
     * @param string $name name
     *
     * @return $this
     */
    public function setName($name)
    {
        $this->container['name'] = $name;

        return $this;
    }

    /**
     * Gets double_size
     *
     * @return double
     */
    public function getDoubleSize()
    {
        return $this->container['double_size'];
    }

    /**
     * Sets double_size
     *
     * @param double $double_size double_size
     *
     * @return $this
     */
    public function setDoubleSize($double_size)
    {
        $this->container['double_size'] = $double_size;

        return $this;
    }

    /**
     * Gets color
     *
     * @return \Aspose\Cells\Cloud\Model\Color
     */
    public function getColor()
    {
        return $this->container['color'];
    }

    /**
     * Sets color
     *
     * @param \Aspose\Cells\Cloud\Model\Color $color color
     *
     * @return $this
     */
    public function setColor($color)
    {
        $this->container['color'] = $color;

        return $this;
    }

    /**
     * Gets is_bold
     *
     * @return bool
     */
    public function getIsBold()
    {
        return $this->container['is_bold'];
    }

    /**
     * Sets is_bold
     *
     * @param bool $is_bold is_bold
     *
     * @return $this
     */
    public function setIsBold($is_bold)
    {
        $this->container['is_bold'] = $is_bold;

        return $this;
    }

    /**
     * Gets is_subscript
     *
     * @return bool
     */
    public function getIsSubscript()
    {
        return $this->container['is_subscript'];
    }

    /**
     * Sets is_subscript
     *
     * @param bool $is_subscript is_subscript
     *
     * @return $this
     */
    public function setIsSubscript($is_subscript)
    {
        $this->container['is_subscript'] = $is_subscript;

        return $this;
    }

    /**
     * Gets is_superscript
     *
     * @return bool
     */
    public function getIsSuperscript()
    {
        return $this->container['is_superscript'];
    }

    /**
     * Sets is_superscript
     *
     * @param bool $is_superscript is_superscript
     *
     * @return $this
     */
    public function setIsSuperscript($is_superscript)
    {
        $this->container['is_superscript'] = $is_superscript;

        return $this;
    }

    /**
     * Gets is_strikeout
     *
     * @return bool
     */
    public function getIsStrikeout()
    {
        return $this->container['is_strikeout'];
    }

    /**
     * Sets is_strikeout
     *
     * @param bool $is_strikeout is_strikeout
     *
     * @return $this
     */
    public function setIsStrikeout($is_strikeout)
    {
        $this->container['is_strikeout'] = $is_strikeout;

        return $this;
    }

    /**
     * Gets underline
     *
     * @return string
     */
    public function getUnderline()
    {
        return $this->container['underline'];
    }

    /**
     * Sets underline
     *
     * @param string $underline underline
     *
     * @return $this
     */
    public function setUnderline($underline)
    {
        $this->container['underline'] = $underline;

        return $this;
    }

    /**
     * Gets size
     *
     * @return int
     */
    public function getSize()
    {
        return $this->container['size'];
    }

    /**
     * Sets size
     *
     * @param int $size size
     *
     * @return $this
     */
    public function setSize($size)
    {
        $this->container['size'] = $size;

        return $this;
    }

    /**
     * Gets outline
     *
     * @return \Aspose\Cells\Cloud\Model\LineFormat
     */
    public function getOutline()
    {
        return $this->container['outline'];
    }

    /**
     * Sets outline
     *
     * @param \Aspose\Cells\Cloud\Model\LineFormat $outline outline
     *
     * @return $this
     */
    public function setOutline($outline)
    {
        $this->container['outline'] = $outline;

        return $this;
    }

    /**
     * Gets spacing
     *
     * @return double
     */
    public function getSpacing()
    {
        return $this->container['spacing'];
    }

    /**
     * Sets spacing
     *
     * @param double $spacing spacing
     *
     * @return $this
     */
    public function setSpacing($spacing)
    {
        $this->container['spacing'] = $spacing;

        return $this;
    }

    /**
     * Gets kerning
     *
     * @return double
     */
    public function getKerning()
    {
        return $this->container['kerning'];
    }

    /**
     * Sets kerning
     *
     * @param double $kerning kerning
     *
     * @return $this
     */
    public function setKerning($kerning)
    {
        $this->container['kerning'] = $kerning;

        return $this;
    }

    /**
     * Gets shadow
     *
     * @return \Aspose\Cells\Cloud\Model\ShadowEffect
     */
    public function getShadow()
    {
        return $this->container['shadow'];
    }

    /**
     * Sets shadow
     *
     * @param \Aspose\Cells\Cloud\Model\ShadowEffect $shadow shadow
     *
     * @return $this
     */
    public function setShadow($shadow)
    {
        $this->container['shadow'] = $shadow;

        return $this;
    }

    /**
     * Gets fill
     *
     * @return \Aspose\Cells\Cloud\Model\FillFormat
     */
    public function getFill()
    {
        return $this->container['fill'];
    }

    /**
     * Sets fill
     *
     * @param \Aspose\Cells\Cloud\Model\FillFormat $fill fill
     *
     * @return $this
     */
    public function setFill($fill)
    {
        $this->container['fill'] = $fill;

        return $this;
    }

    /**
     * Gets underline_color
     *
     * @return \Aspose\Cells\Cloud\Model\CellsColor
     */
    public function getUnderlineColor()
    {
        return $this->container['underline_color'];
    }

    /**
     * Sets underline_color
     *
     * @param \Aspose\Cells\Cloud\Model\CellsColor $underline_color underline_color
     *
     * @return $this
     */
    public function setUnderlineColor($underline_color)
    {
        $this->container['underline_color'] = $underline_color;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     *
     * @param integer $offset Offset
     * @param mixed   $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        if (defined('JSON_PRETTY_PRINT')) { // use JSON pretty print
            return json_encode(
                ObjectSerializer::sanitizeForSerialization($this),
                JSON_PRETTY_PRINT
            );
        }

        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}


