<?php
/**
 * Worksheet
 *
 * PHP version 5
 *
 * @category Class
 * @package  Aspose\Cells\Cloud
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/* 
 * <summary>
 *  Copyright (c) 2020 Aspose.Cells Cloud
 *  Permission is hereby granted, free of charge, to any person obtaining a copy
 *  of this software and associated documentation files (the "Software"), to deal
 *  in the Software without restriction, including without limitation the rights
 *  to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 *  copies of the Software, and to permit persons to whom the Software is
 *  furnished to do so, subject to the following conditions:
 * 
 *  The above copyright notice and this permission notice shall be included in all 
 *  copies or substantial portions of the Software.
 * 
 *  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 *  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 *  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 *  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 *  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 *  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 *  SOFTWARE.
 * </summary>
 */

/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace Aspose\Cells\Cloud\Model;

use \ArrayAccess;
use \Aspose\Cells\Cloud\ObjectSerializer;

/**
 * Worksheet Class Doc Comment
 *
 * @category Class
 * @package  Aspose\Cells\Cloud
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */
class Worksheet implements  ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $swaggerModelName = 'Worksheet';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerTypes = [
        'index' => 'int',
        'pictures' => '\Aspose\Cells\Cloud\Model\LinkElement',
        'charts' => '\Aspose\Cells\Cloud\Model\LinkElement',
        'comments' => '\Aspose\Cells\Cloud\Model\LinkElement',
        'hyperlinks' => '\Aspose\Cells\Cloud\Model\LinkElement',
        'is_visible' => 'bool',
        'view_type' => 'string',
        'type' => 'string',
        'is_gridlines_visible' => 'bool',
        'is_row_column_headers_visible' => 'bool',
        'is_page_break_preview' => 'bool',
        'display_zeros' => 'bool',
        'transition_evaluation' => 'bool',
        'display_right_to_left' => 'bool',
        'first_visible_column' => 'int',
        'ole_objects' => '\Aspose\Cells\Cloud\Model\LinkElement',
        'is_outline_shown' => 'bool',
        'name' => 'string',
        'auto_shapes' => '\Aspose\Cells\Cloud\Model\LinkElement',
        'cells' => '\Aspose\Cells\Cloud\Model\LinkElement',
        'validations' => '\Aspose\Cells\Cloud\Model\LinkElement',
        'zoom' => 'int',
        'conditional_formattings' => '\Aspose\Cells\Cloud\Model\LinkElement',
        'is_selected' => 'bool',
        'tab_color' => '\Aspose\Cells\Cloud\Model\Color',
        'first_visible_row' => 'int',
        'transition_entry' => 'bool',
        'visibility_type' => 'string',
        'is_ruler_visible' => 'bool',
        'links' => '\Aspose\Cells\Cloud\Model\Link[]',
        'is_protected' => 'bool',
        'merged_cells' => '\Aspose\Cells\Cloud\Model\LinkElement'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerFormats = [
        'index' => 'int32',
        'pictures' => null,
        'charts' => null,
        'comments' => null,
        'hyperlinks' => null,
        'is_visible' => null,
        'view_type' => null,
        'type' => null,
        'is_gridlines_visible' => null,
        'is_row_column_headers_visible' => null,
        'is_page_break_preview' => null,
        'display_zeros' => null,
        'transition_evaluation' => null,
        'display_right_to_left' => null,
        'first_visible_column' => 'int32',
        'ole_objects' => null,
        'is_outline_shown' => null,
        'name' => null,
        'auto_shapes' => null,
        'cells' => null,
        'validations' => null,
        'zoom' => 'int32',
        'conditional_formattings' => null,
        'is_selected' => null,
        'tab_color' => null,
        'first_visible_row' => 'int32',
        'transition_entry' => null,
        'visibility_type' => null,
        'is_ruler_visible' => null,
        'links' => null,
        'is_protected' => null,
        'merged_cells' => null
    ];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerTypes()
    {
        return self::$swaggerTypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerFormats()
    {
        return self::$swaggerFormats;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'index' => 'Index',
        'pictures' => 'Pictures',
        'charts' => 'Charts',
        'comments' => 'Comments',
        'hyperlinks' => 'Hyperlinks',
        'is_visible' => 'IsVisible',
        'view_type' => 'ViewType',
        'type' => 'Type',
        'is_gridlines_visible' => 'IsGridlinesVisible',
        'is_row_column_headers_visible' => 'IsRowColumnHeadersVisible',
        'is_page_break_preview' => 'IsPageBreakPreview',
        'display_zeros' => 'DisplayZeros',
        'transition_evaluation' => 'TransitionEvaluation',
        'display_right_to_left' => 'DisplayRightToLeft',
        'first_visible_column' => 'FirstVisibleColumn',
        'ole_objects' => 'OleObjects',
        'is_outline_shown' => 'IsOutlineShown',
        'name' => 'Name',
        'auto_shapes' => 'AutoShapes',
        'cells' => 'Cells',
        'validations' => 'Validations',
        'zoom' => 'Zoom',
        'conditional_formattings' => 'ConditionalFormattings',
        'is_selected' => 'IsSelected',
        'tab_color' => 'TabColor',
        'first_visible_row' => 'FirstVisibleRow',
        'transition_entry' => 'TransitionEntry',
        'visibility_type' => 'VisibilityType',
        'is_ruler_visible' => 'IsRulerVisible',
        'links' => 'Links',
        'is_protected' => 'IsProtected',
        'merged_cells' => 'MergedCells'
    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'index' => 'setIndex',
        'pictures' => 'setPictures',
        'charts' => 'setCharts',
        'comments' => 'setComments',
        'hyperlinks' => 'setHyperlinks',
        'is_visible' => 'setIsVisible',
        'view_type' => 'setViewType',
        'type' => 'setType',
        'is_gridlines_visible' => 'setIsGridlinesVisible',
        'is_row_column_headers_visible' => 'setIsRowColumnHeadersVisible',
        'is_page_break_preview' => 'setIsPageBreakPreview',
        'display_zeros' => 'setDisplayZeros',
        'transition_evaluation' => 'setTransitionEvaluation',
        'display_right_to_left' => 'setDisplayRightToLeft',
        'first_visible_column' => 'setFirstVisibleColumn',
        'ole_objects' => 'setOleObjects',
        'is_outline_shown' => 'setIsOutlineShown',
        'name' => 'setName',
        'auto_shapes' => 'setAutoShapes',
        'cells' => 'setCells',
        'validations' => 'setValidations',
        'zoom' => 'setZoom',
        'conditional_formattings' => 'setConditionalFormattings',
        'is_selected' => 'setIsSelected',
        'tab_color' => 'setTabColor',
        'first_visible_row' => 'setFirstVisibleRow',
        'transition_entry' => 'setTransitionEntry',
        'visibility_type' => 'setVisibilityType',
        'is_ruler_visible' => 'setIsRulerVisible',
        'links' => 'setLinks',
        'is_protected' => 'setIsProtected',
        'merged_cells' => 'setMergedCells'
    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'index' => 'getIndex',
        'pictures' => 'getPictures',
        'charts' => 'getCharts',
        'comments' => 'getComments',
        'hyperlinks' => 'getHyperlinks',
        'is_visible' => 'getIsVisible',
        'view_type' => 'getViewType',
        'type' => 'getType',
        'is_gridlines_visible' => 'getIsGridlinesVisible',
        'is_row_column_headers_visible' => 'getIsRowColumnHeadersVisible',
        'is_page_break_preview' => 'getIsPageBreakPreview',
        'display_zeros' => 'getDisplayZeros',
        'transition_evaluation' => 'getTransitionEvaluation',
        'display_right_to_left' => 'getDisplayRightToLeft',
        'first_visible_column' => 'getFirstVisibleColumn',
        'ole_objects' => 'getOleObjects',
        'is_outline_shown' => 'getIsOutlineShown',
        'name' => 'getName',
        'auto_shapes' => 'getAutoShapes',
        'cells' => 'getCells',
        'validations' => 'getValidations',
        'zoom' => 'getZoom',
        'conditional_formattings' => 'getConditionalFormattings',
        'is_selected' => 'getIsSelected',
        'tab_color' => 'getTabColor',
        'first_visible_row' => 'getFirstVisibleRow',
        'transition_entry' => 'getTransitionEntry',
        'visibility_type' => 'getVisibilityType',
        'is_ruler_visible' => 'getIsRulerVisible',
        'links' => 'getLinks',
        'is_protected' => 'getIsProtected',
        'merged_cells' => 'getMergedCells'
    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$swaggerModelName;
    }

    

    

    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['index'] = isset($data['index']) ? $data['index'] : null;
        $this->container['pictures'] = isset($data['pictures']) ? $data['pictures'] : null;
        $this->container['charts'] = isset($data['charts']) ? $data['charts'] : null;
        $this->container['comments'] = isset($data['comments']) ? $data['comments'] : null;
        $this->container['hyperlinks'] = isset($data['hyperlinks']) ? $data['hyperlinks'] : null;
        $this->container['is_visible'] = isset($data['is_visible']) ? $data['is_visible'] : null;
        $this->container['view_type'] = isset($data['view_type']) ? $data['view_type'] : null;
        $this->container['type'] = isset($data['type']) ? $data['type'] : null;
        $this->container['is_gridlines_visible'] = isset($data['is_gridlines_visible']) ? $data['is_gridlines_visible'] : null;
        $this->container['is_row_column_headers_visible'] = isset($data['is_row_column_headers_visible']) ? $data['is_row_column_headers_visible'] : null;
        $this->container['is_page_break_preview'] = isset($data['is_page_break_preview']) ? $data['is_page_break_preview'] : null;
        $this->container['display_zeros'] = isset($data['display_zeros']) ? $data['display_zeros'] : null;
        $this->container['transition_evaluation'] = isset($data['transition_evaluation']) ? $data['transition_evaluation'] : null;
        $this->container['display_right_to_left'] = isset($data['display_right_to_left']) ? $data['display_right_to_left'] : null;
        $this->container['first_visible_column'] = isset($data['first_visible_column']) ? $data['first_visible_column'] : null;
        $this->container['ole_objects'] = isset($data['ole_objects']) ? $data['ole_objects'] : null;
        $this->container['is_outline_shown'] = isset($data['is_outline_shown']) ? $data['is_outline_shown'] : null;
        $this->container['name'] = isset($data['name']) ? $data['name'] : null;
        $this->container['auto_shapes'] = isset($data['auto_shapes']) ? $data['auto_shapes'] : null;
        $this->container['cells'] = isset($data['cells']) ? $data['cells'] : null;
        $this->container['validations'] = isset($data['validations']) ? $data['validations'] : null;
        $this->container['zoom'] = isset($data['zoom']) ? $data['zoom'] : null;
        $this->container['conditional_formattings'] = isset($data['conditional_formattings']) ? $data['conditional_formattings'] : null;
        $this->container['is_selected'] = isset($data['is_selected']) ? $data['is_selected'] : null;
        $this->container['tab_color'] = isset($data['tab_color']) ? $data['tab_color'] : null;
        $this->container['first_visible_row'] = isset($data['first_visible_row']) ? $data['first_visible_row'] : null;
        $this->container['transition_entry'] = isset($data['transition_entry']) ? $data['transition_entry'] : null;
        $this->container['visibility_type'] = isset($data['visibility_type']) ? $data['visibility_type'] : null;
        $this->container['is_ruler_visible'] = isset($data['is_ruler_visible']) ? $data['is_ruler_visible'] : null;
        $this->container['links'] = isset($data['links']) ? $data['links'] : null;
        $this->container['is_protected'] = isset($data['is_protected']) ? $data['is_protected'] : null;
        $this->container['merged_cells'] = isset($data['merged_cells']) ? $data['merged_cells'] : null;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        if ($this->container['index'] === null) {
            $invalidProperties[] = "'index' can't be null";
        }
        if ($this->container['is_protected'] === null) {
            $invalidProperties[] = "'is_protected' can't be null";
        }
        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {

        if ($this->container['index'] === null) {
            return false;
        }
        if ($this->container['is_protected'] === null) {
            return false;
        }
        return true;
    }


    /**
     * Gets index
     *
     * @return int
     */
    public function getIndex()
    {
        return $this->container['index'];
    }

    /**
     * Sets index
     *
     * @param int $index Gets the index of sheet in the worksheets collection.
     *
     * @return $this
     */
    public function setIndex($index)
    {
        $this->container['index'] = $index;

        return $this;
    }

    /**
     * Gets pictures
     *
     * @return \Aspose\Cells\Cloud\Model\LinkElement
     */
    public function getPictures()
    {
        return $this->container['pictures'];
    }

    /**
     * Sets pictures
     *
     * @param \Aspose\Cells\Cloud\Model\LinkElement $pictures pictures
     *
     * @return $this
     */
    public function setPictures($pictures)
    {
        $this->container['pictures'] = $pictures;

        return $this;
    }

    /**
     * Gets charts
     *
     * @return \Aspose\Cells\Cloud\Model\LinkElement
     */
    public function getCharts()
    {
        return $this->container['charts'];
    }

    /**
     * Sets charts
     *
     * @param \Aspose\Cells\Cloud\Model\LinkElement $charts charts
     *
     * @return $this
     */
    public function setCharts($charts)
    {
        $this->container['charts'] = $charts;

        return $this;
    }

    /**
     * Gets comments
     *
     * @return \Aspose\Cells\Cloud\Model\LinkElement
     */
    public function getComments()
    {
        return $this->container['comments'];
    }

    /**
     * Sets comments
     *
     * @param \Aspose\Cells\Cloud\Model\LinkElement $comments comments
     *
     * @return $this
     */
    public function setComments($comments)
    {
        $this->container['comments'] = $comments;

        return $this;
    }

    /**
     * Gets hyperlinks
     *
     * @return \Aspose\Cells\Cloud\Model\LinkElement
     */
    public function getHyperlinks()
    {
        return $this->container['hyperlinks'];
    }

    /**
     * Sets hyperlinks
     *
     * @param \Aspose\Cells\Cloud\Model\LinkElement $hyperlinks hyperlinks
     *
     * @return $this
     */
    public function setHyperlinks($hyperlinks)
    {
        $this->container['hyperlinks'] = $hyperlinks;

        return $this;
    }

    /**
     * Gets is_visible
     *
     * @return bool
     */
    public function getIsVisible()
    {
        return $this->container['is_visible'];
    }

    /**
     * Sets is_visible
     *
     * @param bool $is_visible Represents if the worksheet is visible.
     *
     * @return $this
     */
    public function setIsVisible($is_visible)
    {
        $this->container['is_visible'] = $is_visible;

        return $this;
    }

    /**
     * Gets view_type
     *
     * @return string
     */
    public function getViewType()
    {
        return $this->container['view_type'];
    }

    /**
     * Sets view_type
     *
     * @param string $view_type Gets and sets the view type.
     *
     * @return $this
     */
    public function setViewType($view_type)
    {
        $this->container['view_type'] = $view_type;

        return $this;
    }

    /**
     * Gets type
     *
     * @return string
     */
    public function getType()
    {
        return $this->container['type'];
    }

    /**
     * Sets type
     *
     * @param string $type Represents worksheet type
     *
     * @return $this
     */
    public function setType($type)
    {
        $this->container['type'] = $type;

        return $this;
    }

    /**
     * Gets is_gridlines_visible
     *
     * @return bool
     */
    public function getIsGridlinesVisible()
    {
        return $this->container['is_gridlines_visible'];
    }

    /**
     * Sets is_gridlines_visible
     *
     * @param bool $is_gridlines_visible Gets or sets a value indicating whether the gridelines are visible.Default     is true.
     *
     * @return $this
     */
    public function setIsGridlinesVisible($is_gridlines_visible)
    {
        $this->container['is_gridlines_visible'] = $is_gridlines_visible;

        return $this;
    }

    /**
     * Gets is_row_column_headers_visible
     *
     * @return bool
     */
    public function getIsRowColumnHeadersVisible()
    {
        return $this->container['is_row_column_headers_visible'];
    }

    /**
     * Sets is_row_column_headers_visible
     *
     * @param bool $is_row_column_headers_visible Gets or sets a value indicating whether the worksheet will display row and column headers.Default is true.
     *
     * @return $this
     */
    public function setIsRowColumnHeadersVisible($is_row_column_headers_visible)
    {
        $this->container['is_row_column_headers_visible'] = $is_row_column_headers_visible;

        return $this;
    }

    /**
     * Gets is_page_break_preview
     *
     * @return bool
     */
    public function getIsPageBreakPreview()
    {
        return $this->container['is_page_break_preview'];
    }

    /**
     * Sets is_page_break_preview
     *
     * @param bool $is_page_break_preview Indications the specified worksheet is shown in normal view or page break preview.
     *
     * @return $this
     */
    public function setIsPageBreakPreview($is_page_break_preview)
    {
        $this->container['is_page_break_preview'] = $is_page_break_preview;

        return $this;
    }

    /**
     * Gets display_zeros
     *
     * @return bool
     */
    public function getDisplayZeros()
    {
        return $this->container['display_zeros'];
    }

    /**
     * Sets display_zeros
     *
     * @param bool $display_zeros True if zero values are displayed.
     *
     * @return $this
     */
    public function setDisplayZeros($display_zeros)
    {
        $this->container['display_zeros'] = $display_zeros;

        return $this;
    }

    /**
     * Gets transition_evaluation
     *
     * @return bool
     */
    public function getTransitionEvaluation()
    {
        return $this->container['transition_evaluation'];
    }

    /**
     * Sets transition_evaluation
     *
     * @param bool $transition_evaluation Flag indicating whether the Transition Formula Evaluation (Lotus compatibility) option is enabled.
     *
     * @return $this
     */
    public function setTransitionEvaluation($transition_evaluation)
    {
        $this->container['transition_evaluation'] = $transition_evaluation;

        return $this;
    }

    /**
     * Gets display_right_to_left
     *
     * @return bool
     */
    public function getDisplayRightToLeft()
    {
        return $this->container['display_right_to_left'];
    }

    /**
     * Sets display_right_to_left
     *
     * @param bool $display_right_to_left Indicates if the specified worksheet is displayed from right to left instead    of from left to right.  Default is false.
     *
     * @return $this
     */
    public function setDisplayRightToLeft($display_right_to_left)
    {
        $this->container['display_right_to_left'] = $display_right_to_left;

        return $this;
    }

    /**
     * Gets first_visible_column
     *
     * @return int
     */
    public function getFirstVisibleColumn()
    {
        return $this->container['first_visible_column'];
    }

    /**
     * Sets first_visible_column
     *
     * @param int $first_visible_column Represents first visible column index.
     *
     * @return $this
     */
    public function setFirstVisibleColumn($first_visible_column)
    {
        $this->container['first_visible_column'] = $first_visible_column;

        return $this;
    }

    /**
     * Gets ole_objects
     *
     * @return \Aspose\Cells\Cloud\Model\LinkElement
     */
    public function getOleObjects()
    {
        return $this->container['ole_objects'];
    }

    /**
     * Sets ole_objects
     *
     * @param \Aspose\Cells\Cloud\Model\LinkElement $ole_objects ole_objects
     *
     * @return $this
     */
    public function setOleObjects($ole_objects)
    {
        $this->container['ole_objects'] = $ole_objects;

        return $this;
    }

    /**
     * Gets is_outline_shown
     *
     * @return bool
     */
    public function getIsOutlineShown()
    {
        return $this->container['is_outline_shown'];
    }

    /**
     * Sets is_outline_shown
     *
     * @param bool $is_outline_shown Indicates whether show outline.
     *
     * @return $this
     */
    public function setIsOutlineShown($is_outline_shown)
    {
        $this->container['is_outline_shown'] = $is_outline_shown;

        return $this;
    }

    /**
     * Gets name
     *
     * @return string
     */
    public function getName()
    {
        return $this->container['name'];
    }

    /**
     * Sets name
     *
     * @param string $name Gets or sets the name of the worksheet.
     *
     * @return $this
     */
    public function setName($name)
    {
        $this->container['name'] = $name;

        return $this;
    }

    /**
     * Gets auto_shapes
     *
     * @return \Aspose\Cells\Cloud\Model\LinkElement
     */
    public function getAutoShapes()
    {
        return $this->container['auto_shapes'];
    }

    /**
     * Sets auto_shapes
     *
     * @param \Aspose\Cells\Cloud\Model\LinkElement $auto_shapes auto_shapes
     *
     * @return $this
     */
    public function setAutoShapes($auto_shapes)
    {
        $this->container['auto_shapes'] = $auto_shapes;

        return $this;
    }

    /**
     * Gets cells
     *
     * @return \Aspose\Cells\Cloud\Model\LinkElement
     */
    public function getCells()
    {
        return $this->container['cells'];
    }

    /**
     * Sets cells
     *
     * @param \Aspose\Cells\Cloud\Model\LinkElement $cells cells
     *
     * @return $this
     */
    public function setCells($cells)
    {
        $this->container['cells'] = $cells;

        return $this;
    }

    /**
     * Gets validations
     *
     * @return \Aspose\Cells\Cloud\Model\LinkElement
     */
    public function getValidations()
    {
        return $this->container['validations'];
    }

    /**
     * Sets validations
     *
     * @param \Aspose\Cells\Cloud\Model\LinkElement $validations validations
     *
     * @return $this
     */
    public function setValidations($validations)
    {
        $this->container['validations'] = $validations;

        return $this;
    }

    /**
     * Gets zoom
     *
     * @return int
     */
    public function getZoom()
    {
        return $this->container['zoom'];
    }

    /**
     * Sets zoom
     *
     * @param int $zoom Represents the scaling factor in percent. It should be btween 10 and 400.
     *
     * @return $this
     */
    public function setZoom($zoom)
    {
        $this->container['zoom'] = $zoom;

        return $this;
    }

    /**
     * Gets conditional_formattings
     *
     * @return \Aspose\Cells\Cloud\Model\LinkElement
     */
    public function getConditionalFormattings()
    {
        return $this->container['conditional_formattings'];
    }

    /**
     * Sets conditional_formattings
     *
     * @param \Aspose\Cells\Cloud\Model\LinkElement $conditional_formattings conditional_formattings
     *
     * @return $this
     */
    public function setConditionalFormattings($conditional_formattings)
    {
        $this->container['conditional_formattings'] = $conditional_formattings;

        return $this;
    }

    /**
     * Gets is_selected
     *
     * @return bool
     */
    public function getIsSelected()
    {
        return $this->container['is_selected'];
    }

    /**
     * Sets is_selected
     *
     * @param bool $is_selected Indicates whether this worksheet is selected when the workbook is opened.
     *
     * @return $this
     */
    public function setIsSelected($is_selected)
    {
        $this->container['is_selected'] = $is_selected;

        return $this;
    }

    /**
     * Gets tab_color
     *
     * @return \Aspose\Cells\Cloud\Model\Color
     */
    public function getTabColor()
    {
        return $this->container['tab_color'];
    }

    /**
     * Sets tab_color
     *
     * @param \Aspose\Cells\Cloud\Model\Color $tab_color Represents worksheet tab color.
     *
     * @return $this
     */
    public function setTabColor($tab_color)
    {
        $this->container['tab_color'] = $tab_color;

        return $this;
    }

    /**
     * Gets first_visible_row
     *
     * @return int
     */
    public function getFirstVisibleRow()
    {
        return $this->container['first_visible_row'];
    }

    /**
     * Sets first_visible_row
     *
     * @param int $first_visible_row Represents first visible row index.
     *
     * @return $this
     */
    public function setFirstVisibleRow($first_visible_row)
    {
        $this->container['first_visible_row'] = $first_visible_row;

        return $this;
    }

    /**
     * Gets transition_entry
     *
     * @return bool
     */
    public function getTransitionEntry()
    {
        return $this->container['transition_entry'];
    }

    /**
     * Sets transition_entry
     *
     * @param bool $transition_entry Flag indicating whether the Transition Formula Entry (Lotus compatibility) option is enabled.
     *
     * @return $this
     */
    public function setTransitionEntry($transition_entry)
    {
        $this->container['transition_entry'] = $transition_entry;

        return $this;
    }

    /**
     * Gets visibility_type
     *
     * @return string
     */
    public function getVisibilityType()
    {
        return $this->container['visibility_type'];
    }

    /**
     * Sets visibility_type
     *
     * @param string $visibility_type Indicates the state for this sheet visibility
     *
     * @return $this
     */
    public function setVisibilityType($visibility_type)
    {
        $this->container['visibility_type'] = $visibility_type;

        return $this;
    }

    /**
     * Gets is_ruler_visible
     *
     * @return bool
     */
    public function getIsRulerVisible()
    {
        return $this->container['is_ruler_visible'];
    }

    /**
     * Sets is_ruler_visible
     *
     * @param bool $is_ruler_visible Indicates whether the ruler is visible. Only apply for page break preview.
     *
     * @return $this
     */
    public function setIsRulerVisible($is_ruler_visible)
    {
        $this->container['is_ruler_visible'] = $is_ruler_visible;

        return $this;
    }

    /**
     * Gets links
     *
     * @return \Aspose\Cells\Cloud\Model\Link[]
     */
    public function getLinks()
    {
        return $this->container['links'];
    }

    /**
     * Sets links
     *
     * @param \Aspose\Cells\Cloud\Model\Link[] $links links
     *
     * @return $this
     */
    public function setLinks($links)
    {
        $this->container['links'] = $links;

        return $this;
    }

    /**
     * Gets is_protected
     *
     * @return bool
     */
    public function getIsProtected()
    {
        return $this->container['is_protected'];
    }

    /**
     * Sets is_protected
     *
     * @param bool $is_protected Indicates if the worksheet is protected.
     *
     * @return $this
     */
    public function setIsProtected($is_protected)
    {
        $this->container['is_protected'] = $is_protected;

        return $this;
    }

    /**
     * Gets merged_cells
     *
     * @return \Aspose\Cells\Cloud\Model\LinkElement
     */
    public function getMergedCells()
    {
        return $this->container['merged_cells'];
    }

    /**
     * Sets merged_cells
     *
     * @param \Aspose\Cells\Cloud\Model\LinkElement $merged_cells merged_cells
     *
     * @return $this
     */
    public function setMergedCells($merged_cells)
    {
        $this->container['merged_cells'] = $merged_cells;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     *
     * @param integer $offset Offset
     * @param mixed   $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        if (defined('JSON_PRETTY_PRINT')) { // use JSON pretty print
            return json_encode(
                ObjectSerializer::sanitizeForSerialization($this),
                JSON_PRETTY_PRINT
            );
        }

        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}


